/*
26.07.2013
Zunächst kurzzeitig Anzeige "Ein", dan
Anzeige "Vor", bis Sensorspannung größer
als Referenzspannung. Dann Anzeige "HALt"
*/
// 4 Siebensegmentanzeigen
#include <avr/io.h>

int LED1=2;
int LED2=3;
int LED3=4;
int LED4=5;
// Segmente g und DP an Pin6 und Pin7
int seg_a=8;  
int seg_b=9;
int seg_c=10;
int seg_d=11;
int seg_e=12;
int seg_f=13;
int seg_g=6;
int seg_dp=7;
int SW1=16; // Analogpins 2,3 und 4
int SW2=17; // werden als Digitaleingänge
int SW3=18; // verwendet
byte Dat_port; 
byte Dat;
byte Dat6;
byte Dat7;
int n;
int j;
int ADC0=0;
int ADC1=1;
int AD_wert;
int AD_sensor;
int AD_wert1;
int AD_sensor1;
unsigned int U1;
unsigned int Ur;
unsigned int Ein;
int Zehntel;
int Hundertstel;
byte Einer;
byte Zehnt;
byte Hundert;
byte AD_ein;
byte ziffer[10]={63,6,91,79,102,109,124,7,127,111};
void setup()
{                
// Pins 8..13(PORTB0..PORTB5) sollen Ausgänge sein
DDRB=B00111111;
pinMode(seg_g,OUTPUT);
pinMode(seg_dp,OUTPUT);
// Pins 2..5 sollen Ausgänge sein
pinMode(LED1,OUTPUT);
pinMode(LED2,OUTPUT);
pinMode(LED3,OUTPUT);
pinMode(LED4,OUTPUT);
pinMode(SW1,INPUT);
digitalWrite(SW1,HIGH); //jeweiligen Pull-UP-Widerstand einschalten
pinMode(SW2,INPUT);
digitalWrite(SW2,HIGH);
pinMode(SW3,INPUT);
digitalWrite(SW3,HIGH);
}

void Dezdarstellung()
{
Ein=U1/10000;
Einer=Ein;
Ur=U1%10000;
Zehntel=Ur/1000;
Zehnt=Zehntel;
Hundertstel=Ur%1000;
Hundert=Hundertstel/100;
for(j=0;j<50;j++)
{
Dat=AD_ein;
Anzeige1();
Dat=ziffer[Einer]+128;//incl. Dezimalpunkt
Anzeige2(); 
Dat=ziffer[Zehnt];
Anzeige3(); 
Dat=ziffer[Hundert];
Anzeige4();
}
}  


void loop()                     
{
//Für eine kurze Zeit wird "EIn" angezeigt   
for (n=0;n<800;n++)
{
//Anzeige "EIn"
Dat=0;     // Anzeige aus
Anzeige1(); 
Dat=121;    // E
Anzeige2(); 
Dat=48;     // I
Anzeige3(); 
Dat=84;     // n
Anzeige4();
}

 while(1)
 {

if(!digitalRead(SW1))
{
AD_wert=analogRead(ADC1)/4;
U1=AD_wert*196;
AD_ein=115;//P für Poti
Dezdarstellung(); // drei Ziffern für die Spannung
}
if(!digitalRead(SW2))
{
AD_wert=analogRead(ADC0)/4;
U1=AD_wert*196;
AD_ein=92;// o für opt. Sensor
Dezdarstellung();  // drei Ziffern für die Spannung
}
if(!digitalRead(SW3))
{
AD_sensor=0;
AD_wert=0;
AD_wert=analogRead(ADC1)/4;
AD_sensor=analogRead(ADC0)/4;

if (AD_sensor <AD_wert) 
{    
for(n=0;n<50;n++)
{
//Anzeige "Vor"
Dat=0;
Anzeige1(); 
Dat=62;
Anzeige2(); 
Dat=92;
Anzeige3(); 
Dat=80;
Anzeige4();
}
}

if(AD_sensor >AD_wert)
{
// Anzeige "HALt"
for(j=0;j<50;j++)
{
Dat=118;//war 118; S  109
Anzeige1(); 
Dat=119;//war 119; t  120
Anzeige2(); 
Dat=56;//war 56;   O  63
Anzeige3(); 
Dat=120;//war 120; P  115
Anzeige4();  
}
}
}
}
}

void Anzeige1()
//Erste Siebensegmentanzeige(links)
{
 LED_Anzeige();
 digitalWrite(LED2,LOW);
   digitalWrite(LED3,LOW);
    digitalWrite(LED4,LOW);
 digitalWrite(LED1,HIGH);
 delay(1); 
}  
void Anzeige2()
{
 LED_Anzeige();
 digitalWrite(LED1,LOW);
   digitalWrite(LED3,LOW);
    digitalWrite(LED4,LOW);
 digitalWrite(LED2,HIGH);
 delay(1); 
}  
void Anzeige3()
{
 LED_Anzeige();
 digitalWrite(LED1,LOW);
   digitalWrite(LED2,LOW);
    digitalWrite(LED4,LOW);
 digitalWrite(LED3,HIGH);
delay(1); 
}  
void Anzeige4()
//Vierte Siebensegmentanzeige
{
LED_Anzeige();
 digitalWrite(LED2,LOW);
   digitalWrite(LED1,LOW);
    digitalWrite(LED3,LOW);
 digitalWrite(LED4,HIGH);
 delay(1); 
}  

void LED_Anzeige()
{
Dat6=Dat & 64 ;
Dat7=Dat & 128;
Dat_port=Dat & 0b00111111;
PORTB=Dat_port;

if (Dat6== 64)
{
digitalWrite(seg_g,HIGH);
}
else
{
digitalWrite(seg_g,LOW);
}

if(Dat7==128)
{
digitalWrite(seg_dp,HIGH);
}
else
{
digitalWrite(seg_dp,LOW);
}
}
